/**
 * Created by kingsley_lee on 16/1/8.
 */
cy = cy || {};
var CYPluginManager = {};

CYPluginManager.OpenApp = {
    className: "org/cocos2dx/javascript/AppActivity",
    params : "",
    onOpenUrlParamsCallBack: function () {
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "()Ljava/lang/String;";
            this.params = jsb.reflection.callStaticMethod(this.className, "onOpenUrlParamsCallBack",sign);
        }
        return this.params;
    }
}

CYPluginManager.orientation = {

    className: cc.sys.os === cc.sys.OS_IOS ? "RootViewController":"com/sast/tw/bbvegasj/utils/OrientationUtils",

    portrait: function () {
        if (cc.sys.isNative) {
            if (cc.sys.os === cc.sys.OS_ANDROID) {
                var sign = "()V";
                jsb.reflection.callStaticMethod(this.className, "OrientationPortrait",sign);
            } else if (cc.sys.os === cc.sys.OS_IOS) {
                jsb.reflection.callStaticMethod(this.className, "OrientationPortrait");
            }
            cc.view.setDesignResolutionSize(RESOLUTIONSIZE.HEIGHT, RESOLUTIONSIZE.WIDTH, cc.ResolutionPolicy.EXACT_FIT);
        }

    },
    landscape: function () {
        if (cc.sys.isNative) {
            if (cc.sys.os === cc.sys.OS_ANDROID) {
                var sign = "()V";
                jsb.reflection.callStaticMethod(this.className, "OrientationLandscape",sign);
            } else if (cc.sys.os === cc.sys.OS_IOS) {
                jsb.reflection.callStaticMethod(this.className, "OrientationLandscape");
            }
            cc.view.setDesignResolutionSize(RESOLUTIONSIZE.WIDTH, RESOLUTIONSIZE.HEIGHT, cc.ResolutionPolicy.EXACT_FIT);
        }

    },
    setCanAutoRotated: function (auto) {
        if (cc.sys.isNative) {
            if (cc.sys.os === cc.sys.OS_ANDROID) {

            } else if (cc.sys.os === cc.sys.OS_IOS) {
                jsb.reflection.callStaticMethod(this.className, "SetCanAutoRotated:", auto);
            }
        }
    }
};

CYPluginManager.AppCtrlUtils = {

    className: cc.sys.os === cc.sys.OS_IOS ? "AppCtrlUtils" : "com/sast/tw/bbvegasj/appctrlutils/AppCtrlUtils",

    getLanguage: function () {
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "()Ljava/lang/String;";
            return jsb.reflection.callStaticMethod(this.className, "AppCtrlGetLanguage",sign);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            return jsb.reflection.callStaticMethod(this.className, "AppCtrlGetLanguage");
        }else{
            return "us";
        }
    },
    checkAppIsExists: function (packageName,versionCode) {
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "(Ljava/lang/String;Ljava/lang/String;)Z";
            return jsb.reflection.callStaticMethod(this.className, "AppCtrlCheckAppIsExists", sign,packageName,versionCode);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            return jsb.reflection.callStaticMethod(this.className, "AppCtrlCheckAppIsExists:",packageName);
        }
    },
    openApp: function (openAppUrl) {
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "(Ljava/lang/String;)V";
            jsb.reflection.callStaticMethod(this.className, "AppCtrlOpenApp", sign,openAppUrl);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            jsb.reflection.callStaticMethod(this.className, "AppCtrlOpenApp:", openAppUrl);
        }
    },
    getApp: function (downloadUrl) {
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "(Ljava/lang/String;)V";
            jsb.reflection.callStaticMethod(this.className, "AppCtrlGetApp", sign, downloadUrl);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            jsb.reflection.callStaticMethod(this.className, "AppCtrlGetApp:", downloadUrl);
        }
    },
    getDevice: function () {
        var deviceType = "";
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "()Ljava/lang/String;";
            return jsb.reflection.callStaticMethod(this.className, "AppCtrlGetDevice", sign);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            return jsb.reflection.callStaticMethod(this.className, "AppCtrlGetDevice");
        }else{
            return cc.sys.os;
        }
    },
    getBundleVersion: function () {
        var version = "0.0.1";
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "()Ljava/lang/String;";
            return jsb.reflection.callStaticMethod(this.className, "AppCtrlGetBundleVersion", sign);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            version = jsb.reflection.callStaticMethod(this.className, "AppCtrlGetBundleVersion");
        }
        return version;
    },
    vibrate: function () {
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "()V";
            jsb.reflection.callStaticMethod(this.className, "AppCtrlPhoneVibrate", sign);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            jsb.reflection.callStaticMethod(this.className, "AppCtrlPhoneVibrate");
        }
    },
    getUUID: function () {
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            return null;
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            return jsb.reflection.callStaticMethod(this.className, "AppCtrlGetUUID");
        }else{
            return null;
        }
    },
    RedrawAllTexture: function () {
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "()V";
            jsb.reflection.callStaticMethod(this.className, "RedrawAllTexture", sign);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            return null;
        }else{
            return null;
        }
    },
    needUpdate: function () {
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            return null;
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            return jsb.reflection.callStaticMethod(this.className, "AppCtrlNeedsUpdate");
        }else{
            return null;
        }
    }
};

CYPluginManager.VideoUtils = {

    className: cc.sys.os === cc.sys.OS_IOS ? "VideoUtils" : "com/sast/tw/bbvegasj/rtmpvideo/VMPlayer",

    openVideo: function (_url, _x, _y, _width, _height) {
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "(IIIILjava/lang/String;)V";
            jsb.reflection.callStaticMethod(this.className, "RTMPVideoOpen", sign,_x, _y, _width, _height,_url);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            jsb.reflection.callStaticMethod(this.className, "VideoUtilsOpenWithUrl:x:y:width:height:", _url, _x, _y, _width, _height);
        }
    },
    //resizeFrame: function (_x, _y, _width, _height) {
    //    if (cc.sys.os === cc.sys.OS_ANDROID) {
    //
    //    } else if (cc.sys.os === cc.sys.OS_IOS) {
    //        jsb.reflection.callStaticMethod(this.className, "VideoUtilsResize", _x, _y, _width, _height);
    //    }
    //},
    //moveFrame: function (_x, _y, _width, _height) {
    //    if (cc.sys.os === cc.sys.OS_ANDROID) {
    //
    //    } else if (cc.sys.os === cc.sys.OS_IOS) {
    //        jsb.reflection.callStaticMethod(this.className, "VideoUtilsMove", _x, _y, _width, _height);
    //    }
    //},
    //bonceShiftY: function(_duration, _posY) {
    //    if (cc.sys.os === cc.sys.OS_ANDROID) {
    //
    //    } else if (cc.sys.os === cc.sys.OS_IOS) {
    //        jsb.reflection.callStaticMethod(this.className, "VideoUtilsBonceShiftY", _duration, _posY);
    //    }
    //},
    setVisible: function(_visible) {
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "(I)V";
            jsb.reflection.callStaticMethod(this.className, "RTMPVideoSetVisible", sign,_visible);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            jsb.reflection.callStaticMethod(this.className, "VideoUtilsSetVisible:", _visible);
        }
    },
    close: function() {
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "()V";
            jsb.reflection.callStaticMethod(this.className, "RTMPVideoClose", sign);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            jsb.reflection.callStaticMethod(this.className, "VideoUtilsClose");
        }
    }
};

CYPluginManager.UmengUtils = {

    className: cc.sys.os === cc.sys.OS_IOS ? "UmengUtils" : "com/sast/tw/bbvegasj/umeng/UmengAnalysisUtils",

    beginLogPageView: function (_pageName)  {
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "(Ljava/lang/String;)V";
            jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsBeginLogPage", sign, _pageName);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsBeginLogPageView:", _pageName);
        }
    },
    endLogPageView: function (_pageName)  {
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "(Ljava/lang/String;)V";
            jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsEndLogPage", sign, _pageName);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsEndLogPageView:", _pageName);
        }
    },
    sendEvent: function (_eventId, _label)  {
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "(Ljava/lang/String;Ljava/lang/String;)V";
            jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsSendEvent", sign, _eventId, _label);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsSendEvent:Label:", _eventId, _label);
        }
    },
    profileSignIn: function (_userID, _provider)  {
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "(Ljava/lang/String;Ljava/lang/String;)V";
            jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsProfileSignIn", sign, _userID, _provider);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            if(arguments.length==1){

            }else if(arguments.length==2){
                jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsProfileSignIn:Provider:", _userID, _provider);
            }
        }
    },
    setUserLevel: function (_level)  {
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "(I)V";
            jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsSetUserLevel", sign, _level);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsSetUserLevel:", _level);
        }
    },
    pay: function (_cash, _source, _arg3, _arg4, _arg5)  {

        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            if (typeof _arg4 !== "undefined" && typeof _arg5 !== "undefined")  {
                // have 5 args
                var sign = "(IILjava/lang/String;II)V";
                jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsPay", sign, _cash, _source, _arg3, _arg4, _arg5);
            } else  {
                // only 3 args
                var sign = "(III)V";
                jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsPay", sign, _cash, _source, _arg3);
            }
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            if (typeof _arg4 !== "undefined" && typeof _arg5 !== "undefined")  {
                // have 5 args
                jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsPay:Source:Item:Amount:Price:", _cash, _source, _arg3, _arg4, _arg5);
            } else  {
                // only 3 args
                jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsPay:Source:Coin:", _cash, _source, _arg3);
            }
        }
    },
    buy: function (_item, _amount, _price)  {
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "(Ljava/lang/String;II)V";
            jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsBuy", sign, _item, _amount, _price);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsBuy:Amount:Price:", _item, _amount, _price);
        }
    },
    use: function (_item, _amount, _price)  {
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "(Ljava/lang/String;II)V";
            jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsUse", sign, _item, _amount, _price);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsUse:Amount:Price:", _item, _amount, _price);
        }
    },
    bonus: function (_coin, _source, _args3, _args4)  {
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            if (typeof _args3 !== "undefined" && typeof _args4 !== "undefined")  {
                // have 4 args
                var sign = "(Ljava/lang/String;III)V";
                jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsBonus", sign, _coin, _source, _args3, _args4);
            } else  {
                // only 2 args
                var sign = "(II)V";
                jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsBonus", sign, _coin, _source);
            }
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            if (typeof _args3 !== "undefined" && typeof _args4 !== "undefined")  {
                // have 4 args
                jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsBonus:Amount:Price:Source:", _coin, _source, _args3, _args4);
            } else  {
                // only 2 args
                jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsBonus:Source:", _coin, _source);
            }
        }
    },
    startLevel: function (_level)  {
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "(Ljava/lang/String;)V";
            jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsStartLevel", sign, _level);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsStartLevel:", _level);
        }
    },
    finishLevel: function (_level)  {
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "(Ljava/lang/String;)V";
            jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsFinishLevel", sign, _level);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsFinishLevel:", _level);
        }
    },
    failLevel: function (_level)  {
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "(Ljava/lang/String;)V";
            jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsFailLevel", sign, _level);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            jsb.reflection.callStaticMethod(this.className, "UmengAnalyticsFailLevel:", _level);
        }
    }
};

CYPluginManager.WebViewUtils = {

    className : cc.sys.os === cc.sys.OS_IOS ? "WebViewUtility" :"com/sast/tw/bbvegasj/webview/WebViewUtilitiesJ",

//    open: function (x,y,width,height,url)  {
//
//        if (cc.sys.os === cc.sys.OS_ANDROID) {
//            var sign = "(IIIILjava/lang/String;)V";
//            jsb.reflection.callStaticMethod(this.className, "WebViewOpen", sign,x,y,width,height,url);
//        } else if (cc.sys.os === cc.sys.OS_IOS) {
//
//        }
//    },
//    close: function ()  {
//
//        if (cc.sys.os === cc.sys.OS_ANDROID) {
//            var sign = "(IIIILjava/lang/String;)V";
//            jsb.reflection.callStaticMethod(this.className, "WebViewClose", sign);
//        } else if (cc.sys.os === cc.sys.OS_IOS) {
//
//        }
//    },
//    reload: function ()  {
//
//        if (cc.sys.os === cc.sys.OS_ANDROID) {
//            var sign = "(IIIILjava/lang/String;)V";
//            jsb.reflection.callStaticMethod(this.className, "WebViewReload", sign);
//        } else if (cc.sys.os === cc.sys.OS_IOS) {
//
//        }
//    },
//    setVisible: function (pVisible)  {
//
//        if (cc.sys.os === cc.sys.OS_ANDROID) {
//            var sign = "(I)V";
//            jsb.reflection.callStaticMethod(this.className, "WebViewSetVisible", sign,pVisible);
//        } else if (cc.sys.os === cc.sys.OS_IOS) {
//
//        }
//    },
    openOutSide: function (url)  {

        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "(Ljava/lang/String;)V";
            jsb.reflection.callStaticMethod(this.className, "WebViewOpenOutSide", sign,url);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            jsb.reflection.callStaticMethod(this.className, "WebViewOpenOutSideWithUrl:", url);
        }
    },
//    canOpenOutSide: function (url)  {
//
//        if (cc.sys.os === cc.sys.OS_ANDROID) {
//            var sign = "(Ljava/lang/String;)I";
//            return jsb.reflection.callStaticMethod(this.className, "WebViewCanOpenOutSide", sign,url);
//        } else if (cc.sys.os === cc.sys.OS_IOS) {
//
//        }
//    },
    clearCookies: function ()  {

        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "()V"
            jsb.reflection.callStaticMethod(this.className, "WebViewClearCookies",sign);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            jsb.reflection.callStaticMethod(this.className, "WebViewClearCookies");
        }
    },
    loadUrl: function(url,id,key){
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V";
            jsb.reflection.callStaticMethod(this.className, "WebViewLoadUrl",sign,url,id,key)
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            jsb.reflection.callStaticMethod(this.className, "WebViewLoadRequestWithKey:ProjectID:TargetUrl:", key, id, url);
        }
    },
    isAlive: function(key){
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "(Ljava/lang/String;)I";
            return jsb.reflection.callStaticMethod(this.className, "WebViewIsAlive", sign,key)
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            return jsb.reflection.callStaticMethod(this.className, "WebViewIsKeyAlive:", key);
        }
    },
    setCookie: function(domain, path, field, value, webviewKey){
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V";
            jsb.reflection.callStaticMethod(this.className, "WebViewSetCookie",sign,domain,path,field,value);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            jsb.reflection.callStaticMethod(this.className, "WebViewSetCookieWithWebViewKey:Domain:CookiePath:Field:Value:", webviewKey, domain, path, field, value);
        }
    },
    clearAll: function(domain, path, field, value){
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "()V";
            jsb.reflection.callStaticMethod(this.className, "WebViewClearAll", sign);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            jsb.reflection.callStaticMethod(this.className, "WebViewClearAll");
        }
    },
    create: function (x,y,width,height,key)  {

        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "(IIIILjava/lang/String;)V"
            jsb.reflection.callStaticMethod(this.className, "WebViewCreate", sign,x,y,width,height,key)
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            jsb.reflection.callStaticMethod(this.className, "WebViewCreateWithKey:X:Y:Width:Height:", key, x, y, width, height);
        }
    },
    reigsterJSHandler: function(delegate, key){
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "(Ljava/lang/String;Ljava/lang/String;)V";
            jsb.reflection.callStaticMethod(this.className, "WebViewReigsterJSHandler",sign,delegate,key);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            jsb.reflection.callStaticMethod(this.className, "WebViewSetJsHandlerWithKey:Delegate:", key, delegate);
        }
    },
    setVisibleWithKey: function(key,visible){
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "(Ljava/lang/String;I)V";
            jsb.reflection.callStaticMethod(this.className, "WebViewSetVisibleWithKey",sign,key,visible);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            jsb.reflection.callStaticMethod(this.className, "WebViewSetVisibleWithKey:IsVisible:", key, visible);
        }
    },
    closeWithKey: function(key){
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "(Ljava/lang/String;)V";
            jsb.reflection.callStaticMethod(this.className, "WebViewCloseWithKey", sign,key);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            jsb.reflection.callStaticMethod(this.className, "WebViewCloseWithKey:", key);
        }
    },
    setInitalScale: function (key, scale) {
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "(Ljava/lang/String;I)V";
            jsb.reflection.callStaticMethod(this.className, "WebViewSetInitalScale", sign,key,scale);
        } else if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {

        }
    },
};

CYPluginManager.WeChatPay = {
    className : cc.sys.os === cc.sys.OS_IOS ? "WeChatPayUtility" :"com/sast/tw/bbvegasj/wechatpay/WeChatPay",

    sendRequest: function(_appId,_partnerId, _prepayId, _package, _nonceStr, _timeStamp, _sign)  {
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative)  {
            var sign = "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)I";
            return jsb.reflection.callStaticMethod(this.className, "WeChatPaySendRequest", sign,_appId,_partnerId, _prepayId, _package, _nonceStr, _timeStamp, _sign);
        } else if (cc.sys.os == cc.sys.OS_IOS && cc.sys.isNative)  {
            return jsb.reflection.callStaticMethod(this.className, "WeChatSendRequest:PartnerId:PrepayId:Package:NonceStr:TimeStamp:Sign:",
                _appId,
                _partnerId,
                _prepayId,
                _package,
                _nonceStr,
                _timeStamp,
                _sign);
        }
    },
    isInstalled: function()  {
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative)  {
            var sign = "()I";
            return jsb.reflection.callStaticMethod(this.className, "WeChatPayIsInstalled", sign);
        } else if (cc.sys.os == cc.sys.OS_IOS && cc.sys.isNative)  {
            return jsb.reflection.callStaticMethod(this.className, "WeChatIsInstalled");
        }
    }
};


CYPluginManager.AudioRecorderUtils = {
    className: cc.sys.os === cc.sys.OS_IOS ? "ItalkingUtils" : "com/sast/tw/bbvegasj/audiorecord/AudioRecorderUtils",

    beginRecord: function () {
        if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            return jsb.reflection.callStaticMethod(this.className, "beginRecord");
        } else if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "()V";
            jsb.reflection.callStaticMethod(this.className, "beginRecord", sign);
        }
    },

    finishRecord: function () {
        if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            return jsb.reflection.callStaticMethod(this.className, "finishRecord");
        } else if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "()V";
            jsb.reflection.callStaticMethod(this.className, "finishRecord", sign);
        }
    },
    uploadAudio: function(serviceId,guestId,uploadAudioURL){
        if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            jsb.reflection.callStaticMethod(this.className, "uploadAudio:guestId:uploadAudioURL:", serviceId,guestId,uploadAudioURL);
        }else if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V";
            jsb.reflection.callStaticMethod(this.className, "uploadAudio", sign,serviceId,guestId,uploadAudioURL);
        }
    },
    playAudio: function(fileName){
        if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            jsb.reflection.callStaticMethod(this.className, "", fileName);
        }else if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "(Ljava/lang/String;)V";
            jsb.reflection.callStaticMethod(this.className, "playAudio", sign, fileName);
        }
    },
    downloadFile: function(fileName, it_host, audioPath){
        cc.log('CYPluginManager.AudioRecorderUtils.downloadFile : ' + fileName + ', ', it_host, + ', ' + audioPath);
        if (cc.sys.os === cc.sys.OS_IOS && cc.sys.isNative) {
            return jsb.reflection.callStaticMethod(this.className, "", fileName, it_host, audioPath);
        }else if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative) {
            var sign = "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Z";
            return jsb.reflection.callStaticMethod(this.className, "downloadFile", sign, fileName, it_host, audioPath);
        }
    }
};

CYPluginManager.SocketIoUtils = {

    className: cc.sys.os === cc.sys.OS_IOS ? "SocketIoUtils" : "com/sast/tw/bbvegasj/socketIO/SocketIoUtils",

    socketConnect: function (userName, serverIP, sid, vendorCode, domain, hallID, gid, uploadHost, uploadAudioPath, uploadImagePath) {
        if (cc.sys.os === cc.sys.OS_ANDROID) {
            var sign = "(Ljava/lang/String;Ljava/lang/String;" +
                "Ljava/lang/String;Ljava/lang/String;" +
                "Ljava/lang/String;Ljava/lang/String;" +
                "Ljava/lang/String;Ljava/lang/String;" +
                "Ljava/lang/String;Ljava/lang/String;)V";
            return jsb.reflection.callStaticMethod(this.className, "SocketConnect", sign,
                userName, serverIP,
                sid, vendorCode,
                domain, hallID,
                gid, uploadHost,
                uploadAudioPath, uploadImagePath);
        } else if (cc.sys.os === cc.sys.OS_IOS) {
            return jsb.reflection.callStaticMethod(this.className, "SocketConnect:", url, appType, sid);
        }
    },
    socketDisconnect: function () {
        if (cc.sys.os === cc.sys.OS_ANDROID) {
            var sign = "()V";
            jsb.reflection.callStaticMethod(this.className, "SocketDisconnect",sign);
        } else if (cc.sys.os === cc.sys.OS_IOS) {
            jsb.reflection.callStaticMethod(this.className, "SocketDisconnect");
        }
    },
    startRecord: function () {
        if (cc.sys.os === cc.sys.OS_ANDROID) {
            var sign = "()V";
            jsb.reflection.callStaticMethod(this.className, "startRecord",sign);
        } else if (cc.sys.os === cc.sys.OS_IOS) {
        }
    },
    stopRecord: function () {
        if (cc.sys.os === cc.sys.OS_ANDROID) {
            var sign = "()V";
            jsb.reflection.callStaticMethod(this.className, "stopRecord",sign);
        } else if (cc.sys.os === cc.sys.OS_IOS) {
        }
    },
    sendMessage: function (event, message) {

        if (cc.sys.os === cc.sys.OS_ANDROID) {
            var sign = "(Ljava/lang/String;Ljava/lang/String;)V";
            jsb.reflection.callStaticMethod(this.className, "sendMessage",sign, event, message);
        } else if (cc.sys.os === cc.sys.OS_IOS) {
            jsb.reflection.callStaticMethod(this.className, "sendMessage", event, message);
        }
    },
    reigsterJSHandler: function(delegate){
        if (cc.sys.os === cc.sys.OS_ANDROID) {
            var sign = "(Ljava/lang/String;)V";
            jsb.reflection.callStaticMethod(this.className, "SocketIORegisterJSHandler",sign,delegate);
        } else if (cc.sys.os === cc.sys.OS_IOS) {
            jsb.reflection.callStaticMethod(this.className, "SocketIORegisterJSHandler", delegate);
        }
    }
};

CYPluginManager.QRCodeScannerUtils = {
    className: cc.sys.os === cc.sys.OS_IOS ? "QRCodeControl":"com/sast/tw/bbvegasj/utils/QRCodeScannerUtils",
    getQRCodeString: function (delegate) {
        if (cc.sys.os === cc.sys.OS_ANDROID) {
            var sign = "(Ljava/lang/String;)V";
            jsb.reflection.callStaticMethod(this.className, "getQRCodeString",sign,delegate);
        } else if (cc.sys.os === cc.sys.OS_IOS) {
            jsb.reflection.callStaticMethod(this.className, "getQRCodeString:",delegate);
        }
    }
}

CYPluginManager.dinPay = {
    className : cc.sys.os === cc.sys.OS_IOS ? "DinpayControl" :"com/sast/tw/bbvegasj/dinpay/dinpay",

    sendRequest: function(orderInfo, completeCB)  {
        if (cc.sys.os === cc.sys.OS_ANDROID && cc.sys.isNative)  {
            var sign = "(Ljava/lang/String;Ljava/lang/String;)V";
            return jsb.reflection.callStaticMethod(this.className, "DinpaySendRequest", sign,orderInfo, completeCB);
        } else if (cc.sys.os == cc.sys.OS_IOS && cc.sys.isNative)  {
            return jsb.reflection.callStaticMethod(this.className, "dinpayOrder:completion:", orderInfo, completeCB);
        }
    }
};