/**
 * Created by kingsley_lee on 15/12/22.
 */
//var lang = cy.util.getCurrentLanguage();
var lang = CYPluginManager.AppCtrlUtils.getLanguage();
var TemplateLocalizable = {};
//category
TemplateLocalizable.localization = {
    COMMON : "Common",
    ErrorMsg : "ErrorMsg"
}

TemplateLocalizable.localization.tw = {
    Common : {
        ResourceUpdate:"資源更新中",
        ResourceLoading:"資源加載中",
        SystemResourceUpdate:"系統資源更新中",
        SystemResourceLoading:"系統資源加載中",
        SystemAudioResourceUpdate:"系統音樂資源更新中",
        SystemAudioResourceLoading:"系統音樂資源加載中",
        GameResoruceLoading : "遊戲資源加載中",
        Retry:"重試",
        UpdateNewVersion:"更新",
        UpdateNewVersionTitle:"發現新版本",
        Confirm:"確定",
        NetworkNotConnect:"沒有網路連線"
    },
    ErrorMsg:{
        168101:"下載檔案錯誤(168101)",
        168102:"請確認您的網路連線能力(168102)",
        168103:"解析錯誤(168103)",
        168104:"更新失敗(168104)",
        168105:"解壓縮失敗(168105)",
        168106:"更新失敗(168106)"
    }
}
TemplateLocalizable.localization.cn = {
    Common : {
        ResourceUpdate:"资源更新中",
        ResourceLoading:"资源加载中",
        SystemResourceUpdate:"系统资源更新中",
        SystemResourceLoading:"系统资源加载中",
        SystemAudioResourceUpdate:"系统音乐资源更新中",
        SystemAudioResourceLoading:"系统音乐资源加载中",
        GameResoruceLoading : "游戏资源加载中",
        Retry:"重试",
        UpdateNewVersion:"更新",
        UpdateNewVersionTitle:"发现新版本",
        Confirm:"确定",
        NetworkNotConnect:"没有网路连线"
    },
    ErrorMsg:{
        168101:"下载档案错误(168101)",
        168102:"请确认您的网路连线能力(168102)",
        168103:"解析错误(168103)",
        168104:"更新失败(168104)",
        168105:"解压缩失败(168105)",
        168106:"更新失败(168106)"
    }
}

TemplateLocalizable.localization.us = {
    Common : {
        ResourceUpdate:"Resource update",
        ResourceLoading:"Resource loading",
        SystemResourceUpdate:"System resource update",
        SystemResourceLoading:"System resource loading",
        SystemAudioResourceUpdate:"System audio resource update",
        SystemAudioResourceLoading:"System audio resource loading",
        GameResoruceLoading : "Game resource loading",
        Retry:"Retry",
        UpdateNewVersion:"Update",
        UpdateNewVersionTitle:"NEW VERSION",
        Confirm:"OK",
        NetworkNotConnect:"Network Not Connect"
    },
    ErrorMsg:{
        168101:"ERROR NO LOCAL MANIFEST(168101)",
        168102:"Please check your internet connection and try again.(168102)",
        168103:"ERROR PARSE MANIFEST(168103)",
        168104:"UPDATE FAILED(168104)",
        168105:"ERROR DECOMPRESS(168105)",
        168106:"ERROR UPDATING(168106)"
    }
}

/**
 * @param category { Type: String }
 * @returns { json Table }
 */
TemplateLocalizable.getLocalizeTableWithCategory = function(category){
    cc.assert(typeof category=="string","[TemplateLocalizable.localization] : category and key can be only a string value");
    return TemplateLocalizable.localization[lang][category];
}
TemplateLocalizable.getCommon = function(){
    return TemplateLocalizable.localization[lang]['Common'];
}
TemplateLocalizable.getErrorMsg = function(){
    return TemplateLocalizable.localization[lang]['ErrorMsg'];
}