/**
 * Created by kingsley_lee on 16/1/20.
 */
var PlatformAlertView = ccui.Layout.extend({
    LAYOUT_WIDTH: 1920.0,
    LAYOUT_HEIGHT:1920.0,

    //ALERT_VIEW_TAG: cy.zOrder.ALERT,
    ALERT_VIEW_TAG: "PlatformAlertView",

    ctor: function(_content, _confirmCallback,_cancellCallback,_isConfirm)  {

        this._super();
        var self = this;

        this.content = _content;
        this.confirmCallback = _confirmCallback;

        this.isConfirm = _isConfirm;
        this.cancellCallback = _cancellCallback;
        // setup content size
        this.setContentSize(cc.size(this.LAYOUT_WIDTH, this.LAYOUT_HEIGHT));

        //// setup background mask
        this.setBackGroundColorType(ccui.Layout.BG_COLOR_SOLID);
        this.setBackGroundColor(cc.color(0, 0, 0));
        this.setOpacity(0);

        // put center
        this.setAnchorPoint(cc.p(0.5, 0.5));
        this.x = this.LAYOUT_WIDTH / 2;
        this.y = this.LAYOUT_HEIGHT / 2;

        // disable transparent touch
        this.setTouchEnabled(true);
    }
});

// create content view
PlatformAlertView.prototype._createContentView = function()  {

    var contentView = new cc.LayerColor(cc.color(0,0,0,125));

    var visibleSize = cc.director.getVisibleSize();
    var origin = cc.director.getVisibleOrigin();

    // create dismiss background
    var spDismissBG = cc.Sprite.create("res/alert/login_alert_view_bg.png");

    var width = cc.winSize.width;
    var height = cc.winSize.height;

    spDismissBG.setPosition(width / 2, height / 2);
    spDismissBG.setScale(1.5, 1.5);
    contentView.addChild(spDismissBG);

    // create contnet Label
    var lbtContent = cc.Label.create();
    lbtContent.setPosition(width / 2, height / 2 + 60);
    lbtContent.setSystemFontSize(50);
    lbtContent.setDimensions(750, 240);
    lbtContent.setAlignment(1, 1);
    lbtContent.setColor(cc.color(0, 0, 0));
    lbtContent.setString(this.content);
    contentView.addChild(lbtContent);

    return contentView;
};

// show result button enter or dismiss by results & delegates
PlatformAlertView.prototype._createResultBtn = function ()  {

    var self = this;
    var commonLangTable = TemplateLocalizable.getCommon();

    // dismiss call back
    var onDismissTouched = function(sender, eventType)  {
        if (eventType != ccui.Widget.TOUCH_ENDED) return;
        if (self.confirmCallback)  {
            self.confirmCallback();
        }

        self.removeFromParent(true);
    }

    var visibleSize = cc.director.getVisibleSize();
    var origin = cc.director.getVisibleOrigin();

    var width = cc.winSize.width;
    var height = cc.winSize.height;

    var layout = new ccui.Layout();
    //layout.setBackGroundColor(cc.color(255,0,0));
    //layout.setBackGroundColorType(ccui.Layout.BG_COLOR_SOLID);
    var layoutWidth = this.LAYOUT_WIDTH/2;
    var layoutHeight = 87;
    layout.attr({
        x : width / 2 - layoutWidth/2,
        y : height / 2 - 120,
        width : layoutWidth,
        height:layoutHeight
    });
    // create OK Button
    var btnDismiss = new ccui.Button();
    btnDismiss.loadTextureNormal("res/alert/login_alert_view_btn_bg.png");
    btnDismiss.setPosition(layout.width/2,10);
    btnDismiss.setTitleColor(cc.color(0x19, 0x55, 0xD1));
    btnDismiss.setTitleFontSize(40);
    btnDismiss.setScale(1.5, 1.5);
    btnDismiss.addTouchEventListener(onDismissTouched);
    btnDismiss.setTitleText(commonLangTable['Confirm']);
    layout.addChild(btnDismiss);

    if(this.isConfirm){

        var cancel = pt.localization.getLocalizeTableWithCategory(pt.localization.COMMON)["Cancel"];

        //btnDismiss.setScale9Enabled(true);
        btnDismiss.setContentSize(layout.width/2,btnDismiss.height);
        btnDismiss.setPosition(layout.width/2 + 180,10);

        var onCancelTouched = function(sender, eventType)  {
            if (eventType != ccui.Widget.TOUCH_ENDED) return;
            if (self.cancellCallback)  {
                self.cancellCallback();
            }

            self.removeFromParent(true);
        }

        var btnCancel = new ccui.Button();
        btnCancel.loadTextureNormal("res/alert/login_alert_view_btn_bg.png");
        btnCancel.setContentSize(layout.width/2,btnCancel.height);
        btnCancel.setScale9Enabled(true);
        btnCancel.setPosition(layout.width/2 - 180 ,10);
        btnCancel.setTitleColor(cc.color(0x19, 0x55, 0xD1));
        btnCancel.setTitleFontSize(40);
        btnCancel.setScale(1.5, 1.5);
        btnCancel.addTouchEventListener(onCancelTouched);
        btnCancel.setTitleText(cancel);

        layout.addChild(btnCancel);
    }
    return layout;
};

//***** Public Methods *****//
PlatformAlertView.prototype.show = function()  {

    var self = this;

    // remove previous alert view
    var prevView = cc.director.getRunningScene().getChildByName(this.ALERT_VIEW_TAG);
    if (prevView)  {
        prevView.removeFromParent(true);
    }

    // set tag
    this.setName(this.ALERT_VIEW_TAG);

    // add to current running scene
    cc.director.getRunningScene().addChild(this, 900009);

    this.contentView = this._createContentView();
    this.contentView.addChild(this._createResultBtn());
    this.addChild(this.contentView);
};

var pt = pt || {}
pt.alert = function(_content, _confirmCallback){
    new PlatformAlertView(_content, _confirmCallback).show();
}

pt.confirm = function(_content, _confirmCallback,_cancelCallback){
    var isConfirm = true;
    new PlatformAlertView(_content, _confirmCallback,_cancelCallback,isConfirm).show();
}