/**
 * Created by kingsley_lee on 16/1/20.
 */
var PlatformSpinnerView = ccui.Layout.extend({
    LAYOUT_WIDTH: 1080.0,
    LAYOUT_HEIGHT:1920.0,

    SPINNER_VIEW_TAG: "PlatformSpinnerView",

    ctor: function()  {

        this._super();
        // setup content size
        this.setContentSize(cc.size(this.LAYOUT_WIDTH, this.LAYOUT_HEIGHT));

        //// setup background mask
        this.setBackGroundColorType(ccui.Layout.BG_COLOR_SOLID);
        this.setBackGroundColor(cc.color(0, 0, 0));
        this.setOpacity(0);

        // put center
        var size = cc.winSize;
        this.setAnchorPoint(cc.p(0.5, 0.5));
        this.x = size.width / 2;
        this.y = size.height / 2;

        // disable transparent touch
        this.setTouchEnabled(true);
    }
});

PlatformSpinnerView.prototype.getLoadingText = function(){
    var loadingText = "Loading";
    var lang = CYPluginManager.AppCtrlUtils.getLanguage();
    if(lang=="tw"){
        loadingText = "讀取中";
    }else if(lang=="cn"){
        loadingText = "读取中";
    }
    return loadingText;
}

// create content view
PlatformSpinnerView.prototype._createContentView = function()  {

    var contentView = new cc.LayerColor(cc.color(0,0,0,125));

    var visibleSize = cc.director.getVisibleSize();
    var origin = cc.director.getVisibleOrigin();

    // create dismiss background
    var spDismissBG = cc.Sprite.create("res/alert/loading_circle_bg.png");
    spDismissBG.setPosition(origin.x + visibleSize.width / 2, origin.y + visibleSize.height / 2);
    spDismissBG.setScale(1.5, 1.5);
    contentView.addChild(spDismissBG);

    var spinner = cc.Sprite.create("res/alert/spinner.png");
    spinner.setPosition(origin.x + visibleSize.width / 2, origin.y + visibleSize.height / 2);
    spinner.setScale(0.6, 0.6);
    var action = cc.rotateBy(1,360);
    spinner.runAction(cc.repeatForever(action));
    contentView.addChild(spinner);

    // create contnet Label
    var lbtContent = cc.Label.create();
    lbtContent.setPosition(origin.x + visibleSize.width / 2, origin.y + visibleSize.height / 2 - 105);
    lbtContent.setSystemFontSize(50);
    lbtContent.setAlignment(1, 1);
    lbtContent.setColor(cc.color(0, 0, 0));
    lbtContent.setString(this.getLoadingText());
    contentView.addChild(lbtContent);

    return contentView;
};

//***** Public Methods *****//
PlatformSpinnerView.prototype.show = function()  {

    var self = this;

    // remove previous alert view
    var prevView = cc.director.getRunningScene().getChildByName(this.SPINNER_VIEW_TAG);
    if (prevView)  {
        prevView.removeFromParent(true);
    }

    // set tag
    this.setName(this.SPINNER_VIEW_TAG);

    // add to current running scene
    cc.director.getRunningScene().addChild(this, 900500);
    this.addChild(this._createContentView());
};

PlatformSpinnerView.prototype.dismiss = function()  {

    // remove previous progress view
    var prevView = cc.director.getRunningScene().getChildByName(this.SPINNER_VIEW_TAG);
    if (prevView)  {
        prevView.removeFromParent(true);
    }
};

var pt = pt || {}
pt.spinner = {
    show:null,
    dismiss:null
}

pt.spinner.show = function(){
    if (cc.sys.isNative)
        new PlatformSpinnerView().show();
}

pt.spinner.dismiss = function(){
    if (cc.sys.isNative)
        new PlatformSpinnerView().dismiss();
}