/**
 * Created by kingsley_lee on 15/12/22.
 */

var UpdateLoadingLayer = cc.Layer.extend({

    ctor:function(){
        this._super();

    },
    onEnter:function() {
        this._super();

        var size = cc.winSize;
        var bg = new cc.Sprite("res/LoginBackground.png");
        bg.x = size.width/2;
        bg.y = size.height/2;
        this.addChild(bg);

        this.progressLabel = new cc.LabelTTF.create("", "Arial", 32);
        this.progressLabel.x = size.width / 2;
        this.progressLabel.y = 50;
        this.addChild(this.progressLabel);

        this.progress = new cc.Sprite("res/progress/pic_loadingbar_1.png");
        this.loadProgress = new cc.ProgressTimer(this.progress);
        this.loadProgress.type = cc.ProgressTimer.TYPE_BAR;
        this.loadProgress.x = size.width/2;
        this.loadProgress.y = 100;
        this.loadProgress.setScaleX(2);
        this.loadProgress.setMidpoint(cc.p(0,0));
        this.loadProgress.setBarChangeRate(cc.p(1, 0));
        this.addChild(this.loadProgress,2);

        var progressBg = new cc.Sprite("res/progress/pic_loadingbar_bg.png");
        progressBg.x = size.width/2;
        progressBg.y = 100;
        progressBg.setScaleX(2);
        this.addChild(progressBg);

        var spinner = cc.Sprite.create("res/progress/loading_animation.png");
        spinner.setPosition(progressBg.x,progressBg.y + 100);
        spinner.setScale(0.6, 0.6);
        var action = cc.rotateBy(1.5,360);
        spinner.runAction(cc.repeatForever(action));
        this.addChild(spinner);

        this.versionLabel = new cc.LabelTTF("", "", 58, cc.size(0, 0), cc.TEXT_ALIGNMENT_RIGHT, cc.VERTICAL_TEXT_ALIGNMENT_CENTER);
        this.versionLabel.x = spinner.x;
        this.versionLabel.y = spinner.y + 200;
        //this.versionLabel.setAnchorPoint(cc.p(1, 0));
        this.addChild(this.versionLabel);

    },
    setPercent:function(percent,animation){
        if(animation){
            this.loadProgress.runAction(new cc.ProgressTo(0.2,percent));
        }else{
            this.loadProgress.setPercentage(percent);
        }

    },setProgressLabel:function(text){
        this.progressLabel.string = text;
    },setVersionCode : function(version){
        this.versionLabel.setString(version);
    }
})