/**
 * Created by kingsley_lee on 15/12/22.
 */
var UpdateLocalProjectManifestPresenter = function(_view,_model){

    this._view = _view;
    this.commonTable = TemplateLocalizable.getCommon();
    this.errorTable = TemplateLocalizable.getErrorMsg();

    var self = this;

    var systemResourceLoading = self.commonTable['SystemResourceLoading'];
    var resourceLoading = self.commonTable['ResourceLoading'];
    var resourceUpdate = self.commonTable['ResourceUpdate'];

    var updateCYCocosSDK = function (cb) {
        self._view.setPercent(0);
        self._view.setProgressLabel(systemResourceLoading + " 0 %");
        self.cysdkAsstesManager = new PlatformAsstesManager(LOCAL_PROJECT_MANIFEST_PATH.CYCOCOS_SDK,HOT_UPDATE_DIRECTORY.CYCOCOS_SDK);
        self.cysdkAsstesManager.update(new function(){
            this.onError = function(errCode){
                cb("[updateCYCocosSDK]"+errCode);
                pt.alert(self.errorTable[errCode]);
            }

            this.onProgress = function(percent){
                self._view.setPercent(percent);
                self._view.setProgressLabel(systemResourceLoading + " " + parseInt(percent) + " %");
            }

            this.onFinished = function(){
                cc.log("updateCYCocosSDK onFinished");
                cb(null);
            }
        });
    }

    var updatePlatformTemplate = function (cb) {

        self._view.setPercent(0);
        self._view.setProgressLabel(resourceLoading + " 0 %");
        self.ptAsstesManager = new PlatformAsstesManager(LOCAL_PROJECT_MANIFEST_PATH.PLATFORM_TEMPLATE,HOT_UPDATE_DIRECTORY.PLATFORM_TEMPLATE);
        self.ptAsstesManager.update(new function(){
            this.onError = function(errCode){
                cb("[updatePlatformTemplate]"+errCode);
                pt.alert(self.errorTable[errCode]);
            }

            this.onProgress = function(percent){
                self._view.setPercent(percent);
                self._view.setProgressLabel(resourceLoading + " " + parseInt(percent) + " %");
            }

            this.onFinished = function(){
                cc.log("updatePlatformTemplate onFinished");
                cb(null);
            }

            this.onVersion = function(version){
                self._view.setVersionCode("V " + version);
            }
        });
    }

    var updateCustomTemplate= function (cb) {
        self._view.setPercent(0);
        self._view.setProgressLabel(resourceUpdate + " 0 %");

        //預設版面
        var customTemplate = "bbin";
        self.customAsstesManager = new PlatformAsstesManager(getLocalCustomProjectManifestPath(customTemplate),customTemplate);
        self.customAsstesManager.update(new function(){
            this.onError = function(errCode){
                cb("[updateCustomTemplate]"+errCode);
                pt.alert(self.errorTable[errCode]);
            }

            this.onProgress = function(percent){
                self._view.setPercent(percent);
                self._view.setProgressLabel(resourceUpdate + " " + parseInt(percent) + "%");
            }

            this.onFinished = function(){
                cc.log("updateCustomTemplate onFinished");
                cb(null);
            }
        });
    }

    var updateLocalProjectManifest = function (onUpdateCompletedListener) {

        self.pmAsstesManager = new PlatformAsstesManager(PLATFORM_MANIFEST_PATH,HOT_UPDATE_DIRECTORY.LOCAL_VERSION_MANIFEST);
        self.pmAsstesManager.update(new function(){
            this.onError = function(errCode){
                cc.log("[updateLocalProjectManifest]"+errCode);
                pt.alert(self.errorTable[errCode],function(){updateLocalProjectManifest(onUpdateCompletedListener)});
            }

            this.onProgress = function(percent){
            }

            this.onFinished = function(){
                cc.async.series([updateCYCocosSDK,updatePlatformTemplate,updateCustomTemplate],function(errCode){
                    if(errCode!=null){
                        cc.log(errCode);
                    }else{
                        self._view.setPercent(100);
                        self._view.setProgressLabel(resourceUpdate + " 100 %");
                        cc.log("updateCYCocosSDK,updatePlatformTemplate,updateCustomTemplate completed");
                        //setTimeout(function(){
                            if(onUpdateCompletedListener){
                                onUpdateCompletedListener();
                            }
                        //},300);
                    }
                });
            }
        });
    }

    this.updateResource = function(onUpdateCompletedListener){
        updateLocalProjectManifest(onUpdateCompletedListener);
    }
}