/**
 * Created by kingsley_lee on 15/11/13.
 */
var AssetsManagerLoaderScene = cc.Scene.extend({

    onEnter: function () {
        this._super();
        this.preload();

    },
    preload: function () {

        if (isReadLocal || isIOS) {
            if (cc.sys.isNative) {
                jsb.fileUtils.addSearchPath(cy.path.platformTemplate  + "src");
                jsb.fileUtils.addSearchPath(cy.path.platformTemplate + "res");
            }
            this.loadGame();
            return;
        }

        var self = this;
        var UpdateLoadingGroup = {
            View: null,
            Presenter: null,
            Model: null
        };

        UpdateLoadingGroup.View = new UpdateLoadingLayer();
        UpdateLoadingGroup.Presenter = new UpdateLocalProjectManifestPresenter(UpdateLoadingGroup.View, UpdateLoadingGroup.Model);
        this.addChild(UpdateLoadingGroup.View);

        UpdateLoadingGroup.Presenter.updateResource(function () {
            self.loadGame();
        });


    },
    loadGame: function () {
        var _loadingCallback = function () {
            cy.preLoadScene([
                {LoadBlock: ["LoginLayer"], Res: pt.res},
                {LoadBlock: ["GetPasswordLayer"], Res: pt.res}
                //{LoadBlock: ["SDK"], Res:cy.res}
            ], function () {
                //var transitionScene = new cc.TransitionFade(0.3, new MainScene());
                var transitionScene = new cc.TransitionFade(0.3, new LoginScene());
                cc.director.runScene(transitionScene);
            }, this);
        };

        //載入SDK熱更新檔案
        cy.loadJsList(cy.path.sdk, "CYPackage.json", function () {
            //載入大廳公版熱更新檔案
            if (cc.sys.isNative) {
                cy.loadJsList(cy.path.platformTemplate, "CYPackage.json", function () {

                    //if(isRelease &&  AppUpdateUtility.checkAppUpdate()){
                    //    return;
                    //}
                    _loadingCallback();
                });
            } else {
                cy.loadJsList(cy.path.sdk, "CYHTMLPackage.json", function () {
                    cy.loadJsList(cy.path.platformTemplate, "CYPackage.json", function () {
                        _loadingCallback();
                    });
                });
            }
        });

    },
    onExit: function () {
        cc.log("AssetsManager::onExit");
        this._super();
    }
});