/**
 * Created by kingsley_lee on 15/11/20.
 */
var cy = cy || {};

var RESOLUTIONSIZE = {
    WIDTH :1920,
    HEIGHT : 1080
    //WIDTH :768,
    //HEIGHT : 432
};

/**
 * Debug Mode
 * @type {boolean}
 */
cy.isDebug = true;
/**
 * 是否發布正式版
 * @type {boolean}
 */
var isRelease = true;

/**
 * 是否讀取本地端檔案 true:非熱更新;false:熱更新
 * @type {boolean}
 */
var isReadLocal = false;
isReadLocal = !cc.sys.isNative ? true : isReadLocal; //是網頁就不會跑熱更新
/**
 * Release Version
 * @type {number}
 */
var APP_TYPE = {
    APP_AIO:0,
    APP_BBLIVE:1,
    APP_BBCASINO:2
};
var gAppType = 0;
var isIOS = cc.sys.os === cc.sys.OS_IOS;

/**
 * Switch game
 * @type {number}
 */
var DEBUG_MODETYPE = {
    D_DEFAULT:0,
    D_VIDEO_GAME:1,
    D_LOTTERY_GAME:2,
    D_ITALKING:3,
    D_UNIT_TEST:4,
    D_SLOT_GAME:5,
    D_WEB_LOGIN:6,
    D_WEB_TEST:7,
    D_CUSTOM_TEST:10
};

var gDebugModeIs = 0;

var jsb = jsb || {};

var ASSTES_DOWNLOADPATH = (jsb.fileUtils ? jsb.fileUtils.getWritablePath() : "./") + "Download/";

if(cc.sys.isNative){
    jsb.fileUtils.addSearchPath("platform/");
}

//熱更新目錄名稱
var HOT_UPDATE_DIRECTORY = {
    //下載所有熱更新檔的version.manifest檔案
    VERSION_MANIFEST : "VersionManifest",
    LOCAL_VERSION_MANIFEST : "LocalVersionManifest",
    CYCOCOS_SDK : "CYCocosSDK",
    PLATFORM_TEMPLATE : "PlatformTemplate",
    VIDEO_TEMPLATE:"VideoGameTemplate",
    LOTTERY_TEMPLATE: "LotteryGamesTemplate",
    SLOT_TEMPLATE: "SlotGameTemplate"
};


//熱更新project.manifest路徑
var BASE_PROJECT_MANIFEST_PATH = ASSTES_DOWNLOADPATH + HOT_UPDATE_DIRECTORY.LOCAL_VERSION_MANIFEST + "/" + HOT_UPDATE_DIRECTORY.VERSION_MANIFEST + "/";
var LOCAL_PROJECT_MANIFEST_PATH = {
    PRODUCTION : "res/project.manifest",
    TEST : "res/test-project.manifest",
    //CYCocosSDK
    CYCOCOS_SDK : BASE_PROJECT_MANIFEST_PATH + HOT_UPDATE_DIRECTORY.CYCOCOS_SDK + "/project.manifest",
    //大廳公版
    PLATFORM_TEMPLATE : BASE_PROJECT_MANIFEST_PATH + HOT_UPDATE_DIRECTORY.PLATFORM_TEMPLATE + "/project.manifest",
    VIDEO_TEMPLATE : BASE_PROJECT_MANIFEST_PATH + HOT_UPDATE_DIRECTORY.VIDEO_TEMPLATE + "/project.manifest",
    LOTTERY_TEMPLATE : BASE_PROJECT_MANIFEST_PATH + HOT_UPDATE_DIRECTORY.LOTTERY_TEMPLATE + "/project.manifest",
    SLOT_TEMPLATE : BASE_PROJECT_MANIFEST_PATH + HOT_UPDATE_DIRECTORY.SLOT_TEMPLATE + "/project.manifest"
};

/**
 * 取得客製化大廳local project manifest path
 * @returns {string}
 */
var getLocalCustomProjectManifestPath = function(custom){
    return BASE_PROJECT_MANIFEST_PATH + custom + "/project.manifest"
};

var PLATFORM_MANIFEST_PATH = isRelease ? LOCAL_PROJECT_MANIFEST_PATH.PRODUCTION : LOCAL_PROJECT_MANIFEST_PATH.TEST;


/**
 * 非客製化廳主的公版,預設為bbin
 * @type {string}
 */
var customTemplate = "bbin";
/**
 * 客製化Game的Project,default is Baccarat
 * @type {string}
 */
//var customVideoGame = "LiveDealer/Baccarat"; // 快速百家樂

//var customVideoGame = "BBBID"; // 競咪
//var customVideoGame = "Bull";         // 牛牛
//var customVideoGame = "BlackJack"; // 21點
//var customVideoGame = "DragonTiger"; // 龍虎鬥
var customVideoGame = "Baccarat"; // 百家樂
//var customVideoGame = "Holdem"; // 德州
//var customVideoGame = "BBVIP"; // 包桌
//var customVideoGame = "Sedie"; // 色碟
//var customVideoGame = "FanTan"; // 番攤
//var customVideoGame = "Roulette"; // 輪潘
//var customVideoGame = "ThreeFace"; // 三公
//var customVideoGame = "Sicbo"; // 骰寶
//var customVideoGame = "Paigow"; // 牌九
//var customVideoGame = "Tt"; // 二八槓

var customLotteryGame = "LotteryGame";
var customSlotGame = "5099";

var cy = cy || {};
cy.path = cy.path || {};

//設定src初始路徑, Web Always read local file
if(isReadLocal || !cc.sys.isNative){
    //讀取本地檔案
    cy.path.sdk = "CYCocosSDK/";
    cy.path.platformTemplate = "PlatformTemplate/";
    cy.path.videoTemplate = "VideoGameTemplate/";
    cy.path.videoTemplateBgm = "VideoGameTemplate/bgm/";
    cy.path.lotteryTemplate = "AllLotteryGames/LotteryGamesTemplate/";

    cy.path.slotGameTemplate = "SlotGameTemplate/";

    //For local test
    cy.path[customLotteryGame] = "AllLotteryGames/" + customLotteryGame + "/";
}else{
    //熱更新
    cy.path.sdk  = ASSTES_DOWNLOADPATH + "CYCocosSDK/CYCocosSDK/";
    cy.path.platformTemplate     = ASSTES_DOWNLOADPATH + "PlatformTemplate/PlatformTemplate/";
    cy.path.videoTemplate = ASSTES_DOWNLOADPATH + "VideoGameTemplate/VideoGameTemplate/";
    cy.path.videoTemplateBgm = ASSTES_DOWNLOADPATH + "VideoGameTemplate/bgm/";
    cy.path.lotteryTemplate = ASSTES_DOWNLOADPATH + "LotteryGamesTemplate/LotteryGamesTemplate/";
    cy.path.slotGameTemplate = ASSTES_DOWNLOADPATH + "SlotGameTemplate/SlotGameTemplate/";

    //送審apple app store 版本 CYCocosSDK & PlatformTemplate 不走熱更新流程
    if(isIOS){
        cy.path.sdk = "CYCocosSDK/";
        cy.path.platformTemplate = "PlatformTemplate/";
        cy.path.slotGameTemplate = "SlotGameTemplate/";
    }
}

var restoreHotUpdatePath = function(){
    cy.path.sdk  = ASSTES_DOWNLOADPATH + "CYCocosSDK/CYCocosSDK/";
    cy.path.platformTemplate = ASSTES_DOWNLOADPATH + "PlatformTemplate/PlatformTemplate/";
    cy.path.slotGameTemplate = ASSTES_DOWNLOADPATH + "SlotGameTemplate/SlotGameTemplate/";
}
var restoreLocalPathForBBG = function(){
    cy.path.sdk = "CYCocosSDK/";
    cy.path.platformTemplate = "PlatformTemplate/";
    cy.path.slotGameTemplate = "SlotGameTemplate/";
}

